#include "settingswindow.h"
#include "mainwindow.h"

SettingsWindow::SettingsWindow(QWidget *parent)
    : QDialog(parent)
{

    settings=new Q::Settings("nausea.conf");
    connect(this,SIGNAL(rejected()),this,SLOT(close()));

    setupWidgets();
}

void SettingsWindow::setupWidgets()
{
    QGridLayout *layout = new QGridLayout;

    QLabel *proxytext=new QLabel(tr("Proxy Server"));
    proxy=new QLineEdit((*settings)["proxy"].c_str());
    QLabel *porttext=new QLabel(tr("Proxy Port"));
    port=new QLineEdit((*settings)["port"].c_str());
    QLabel *proxyusertext=new QLabel(tr("Proxy User"));
    proxyuser=new QLineEdit((*settings)["user"].c_str());
    QLabel *proxypasstext=new QLabel(tr("Proxy Pass"));
    proxypass=new QLineEdit((*settings)["pass"].c_str());
    okbutton=new QPushButton(tr("OK"));
    okbutton->setDefault(true);

    layout->setMargin (5);
    layout->addWidget(proxytext, 0, 0, Qt::AlignTop | Qt::AlignLeft );
    layout->addWidget(proxy, 0, 1,  Qt::AlignTop | Qt::AlignLeft );
    layout->addWidget(porttext, 1, 0, Qt::AlignTop | Qt::AlignLeft );
    layout->addWidget(port, 1, 1,  Qt::AlignTop | Qt::AlignLeft );
    layout->addWidget(proxyusertext, 2, 0, Qt::AlignTop | Qt::AlignLeft );
    layout->addWidget(proxyuser, 2, 1,  Qt::AlignTop | Qt::AlignLeft );
    layout->addWidget(proxypasstext, 3, 0, Qt::AlignTop | Qt::AlignLeft );
    layout->addWidget(proxypass, 3, 1,  Qt::AlignTop | Qt::AlignLeft );
    layout->addWidget(okbutton, 4, 1,  Qt::AlignBottom | Qt::AlignRight );

    connect(okbutton, SIGNAL(clicked()), this, SLOT(close()));

    setLayout(layout);
    proxy->setFocus();
}

SettingsWindow::~SettingsWindow()
{
    (*settings)["proxy"]=proxy->text().toStdString();
    (*settings)["port"]= port->text().toStdString();
    (*settings)["user"]= proxyuser->text().toStdString();
    (*settings)["pass"]= proxypass->text().toStdString();

    delete settings;
}

void SettingsWindow::closeEvent(QCloseEvent *event)
{
    event->accept();
}

